# Cisco devices


sub cisco_discovery {
   $description = shift;

   if ($description =~ m/C2960-(.*)Version ([0-9.]*)\(([0-9]*)\)/) {
      print "OK : ".$1." - ".$2." (".$3.")\n";

   }
   return $description;
}




# Fonctions to enhance Vlan queries

sub cisco_trunk_port {
	while (($object,$oid) = each (%ArraySNMPwalk)) {
		if ($object =~ m/$SNMPwalk{'cdpCacheAddress'}/) {
			$snmpportID = $object;
			$object_src = $SNMPwalk{"cdpCacheAddress"}.".";
			$snmpportID =~ s/$object_src//;
			@explode = split(/\./, $snmpportID);
			$ifIndex = $explode[0];
			$Array_trunk_ifIndex[$ifIndex] = 1;
		}
	}
	return $Array_trunk_ifIndex;
}



sub cisco_vlans {
	# Correspond to function GetMACtoPort from Tracker server
	# For each VLAN

	# Get by SNMP query the mac addresses and IP (ipNetToMediaPhysAddress)
#	%ArraySNMP = ();
#	%ArrayIPMACAdressePhys = snmpwalk($SNMPwalk{"ipNetToMediaPhysAddress"});
#	if(undef %ArrayIPMACAdressePhys) {
#		return;
#	}


	($object,$oid) = snmpgetnext($SNMPwalk{"ipNetToMediaPhysAddress"},$SNMPwalk{"ipNetToMediaPhysAddress"});
	if ($object eq "") {
		return;
	}
	$ipNetToMediaPhysAddress_object = $object;
	$ipNetToMediaPhysAddress_oid = $oid;

	%ArraySNMP = ();
#	%ArrayMACAdressTable = snmpwalk($SNMPwalk{"dot1dTpFdbAddress"});
	$oid_prec = $SNMPwalk{"dot1dTpFdbAddress"};
	while (1 != 2) {
		($dynamicdata,$value_oid) = snmpgetnext($SNMPwalk{"dot1dTpFdbAddress"},$oid_prec);
		if ($dynamicdata eq "") {
			last;
		}
		$oid_prec = $dynamicdata;

		$dot1dTpFdbAddress_object = $dynamicdata;
		$dot1dTpFdbAddress_oid = $value_oid;
		$object = $SNMPwalk{"dot1dTpFdbAddress"}.".";
		$dynamicdata =~ s/$object//;
		@oidExplode = split(/\./, $dynamicdata);
		if (@oidExplode > 3) {
			%ArraySNMP = ();
			$BridgePortNumber = snmpget($SNMPwalk{"dot1dTpFdbPort"}.".".$dynamicdata);
			if ($BridgePortNumber ne "null") {
				$dot1dTpFdbPort_object = $SNMPwalk{"dot1dTpFdbPort"}.".".$dynamicdata;
				$dot1dTpFdbPort_oid = $BridgePortNumber;
				%ArraySNMP = ();
				$BridgePortifIndex = snmpget($SNMPwalk{"dot1dBasePortIfIndex"}.".".$BridgePortNumber);
				$stop = 0;
				if ($BridgePortifIndex ne "null") {
					if (($BridgePortifIndex eq "No Such Instance currently exists at this OID") || ($BridgePortifIndex eq "") || ($BridgePortifIndex eq "noSuchInstance")) {
						$stop = 1;
					} elsif ($BridgePortifIndex eq "") {
						$stop = 1;
					} elsif (defined($Array_trunk_ifIndex[$BridgePortifIndex])) {
						# Port is trunk?
						if ($Array_trunk_ifIndex[$BridgePortifIndex] eq "1") {
							$stop = 1;
						}
					}
				} else {
					$stop = 1;
				}
            if (defined $MACDeny{$dot1dTpFdbAddress_oid}) {
               $stop = 1;
            }

				if ($stop eq "0") {
					$ArraySNMPwalk_vlan{$dot1dTpFdbAddress_object} = $dot1dTpFdbAddress_oid;
					$ArraySNMPwalk_vlan{$dot1dTpFdbPort_object} = $dot1dTpFdbPort_oid;
					$ArraySNMPwalk_vlan{$SNMPwalk{"dot1dBasePortIfIndex"}.".".$BridgePortNumber} = $BridgePortifIndex;
					$ArraySNMPwalk_vlan{$ipNetToMediaPhysAddress_object} = $ipNetToMediaPhysAddress_oid;
				}
			}
		}
	}
	return %ArraySNMPwalk_vlan;
}


1;